/**
 * @file
 * Javascript for Color Field.
 */

(function ($, Drupal, drupalSettings) {


        
    $('#noahs_page_builder_preview').on('load', function() {
        this.contentWindow.noahs_page_builderOpenModal = noahs_page_builderOpenModal;
        this.contentWindow.noahs_page_builderAddColum = noahs_page_builderAddColum;
        this.contentWindow.addElementWidgetModal = addElementWidgetModal;
        this.contentWindow.removeWidgets = removeWidgets;
        this.contentWindow.addWidget = addWidget;
        this.contentWindow.noahs_page_builderSavePage = noahs_page_builderSavePage;
        this.contentWindow.getWidgetStructure = getWidgetStructure;
        this.contentWindow.updateIframeFunctions = updateIframeFunctions;
        this.contentWindow.regenerateWidget = regenerateWidget;
    });
 
    $(document).keydown(function (e) {
        if ((e.ctrlKey || e.metaKey) && e.keyCode === 83) {
            e.preventDefault();    
            $('#noahs_page_builder_form_builder').submit();
        }
    });
    
    // $(document).ajaxStart(function() {
    //     $('body').append('<div class="noahs_page_builder_loading"><div class="spinner-grow text-primary" role="status"><span class="visually-hidden">Loading...</span></div></div>');
    // });
    
    // $(document).ajaxStop(function() {
    //     $('.noahs_page_builder_loading').remove();
    // });

    $(document).on("click", '[data-show-click]', function(e){
        e.preventDefault();
        var element = $(this).data('show-click');
        $('[data-show-click]').addClass('hidden');
        $(element).toggleClass('hidden');
    })
    $(document).on("click", '.move-modal', function(e){
        e.preventDefault();
        $('.noahs_page_builder-modal').toggleClass('right');
    })

    $(document).on("click", '.media-select-icon', function(e){
        e.preventDefault();
        var element_id  = $(this).data('element-id');
        var delta  = $(this).data('delta');
        var widget_id = $(this).closest('form').find('input[name="wid"]').val();
        openIconModal(element_id, delta, widget_id);
    })
    

    $(document).on("keyup", '.noahs_update_stars', function(e){
        var widget_id = $(this).closest('form').find('input[name="wid"]').val();
        var numero  = $(this).val();
        var total = 5;
        var porcentaje = (numero / total) * 100;
        $('#noahs_page_builder_preview').contents().find('#widget-id-' + widget_id + ' .stars-inner').css({
            "width": porcentaje + '%',
        });      
    
    })

    $(document).on("click", '.media-remove-icon', function(e){
        e.preventDefault();

        $(this).closest('.media-preview-actions').find('input').val('');
        $(this).closest('.media-preview-actions').find('span').attr('class', '');
        $(this).closest('.media-preview-actions').find('.image-svg').addClass('hidden');
        const widget_id = $(this).closest('form').find('input[name="wid"]').val();


        var formData = $(this).closest('form').find(':input').filter(function () {
            return $.trim(this.value).length > 0
        }).serializeJSON();
        regenerateWidget(widget_id, formData);
    })
    
    $(document).on("click", '.noahs_page_builder-modal-tokens', function(e){
        e.preventDefault();
        
        openDialogToken();
    })


    $(document).on("keyup", '[data-update-selector]', function(e){
        e.preventDefault();
        var selector = $(this).data('update-selector');
        var contenidoIframe = $('#noahs_page_builder_preview').contents().find(selector);
        $(contenidoIframe).html($(this).val());
        $('.update_data_form').trigger('change');
    
    })

    $(document).on("change", '[data-update-selectorhtml]', function(e){
        e.preventDefault();
        var contenidoIframe = $('#noahs_page_builder_preview').contents();
        var selectedValue = $(this).val();
        var selector = $(this).data('update-selectorhtml');
        var html = contenidoIframe.find(selector).html();
        var newHTML = $('<' + selectedValue + '>').html(html);
        contenidoIframe.find(selector).replaceWith(newHTML);
    })
    
    $(document).on("change", '.field__noahs_select_design input', function(e){
        e.preventDefault();
        const widget_id = $(this).closest('form').find('input[name="wid"]').val();
        var selectedValue = $(this).val();

        var formData = $(this).closest('form').find(':input').filter(function () {
            return $.trim(this.value).length > 0
        }).serializeJSON();

        regenerateWidget(widget_id, formData);
    })
    $(document).on("change", '.noahs-regenerate-design', function(e){
        e.preventDefault();
        const widget_id = $(this).closest('form').find('input[name="wid"]').val();
        var selectedValue = $(this).val();

        var formData = $(this).closest('form').find(':input').filter(function () {
            return $.trim(this.value).length > 0
        }).serializeJSON();

        regenerateWidget(widget_id, formData);
    })

    $(document).on("click", '.close-media-modal', function(e){
        e.preventDefault();
        $('.noahs_page_builder-media-modal').remove();
    })
    

    $(document).on("click", '.media-remove_mask_image', function(e){
        e.preventDefault();
        $(this).closest('.media-preview-actions--mask').find('input').prop('checked', false);
        $(this).closest('.media-preview-actions--mask').find('input[checked]').trigger('change');
        const widget_id = $(this).closest('form').find('input[name="wid"]').val();
        var formData = $(this).closest('form').find(':input').filter(function () {
            return $.trim(this.value).length > 0
        }).serializeJSON();

        regenerateWidget(widget_id, formData);
    })
    
    $(document).on("click", '.media-remove_divider', function(e){
        e.preventDefault();
        $(this).closest('.media-preview-actions--divider').find('input').prop('checked', false);
        $(this).closest('.media-preview-actions--divider').find('input[checked]').trigger('change');

        const widget_id = $(this).closest('form').find('input[name="wid"]').val();
        var type =  $(this).data('type');

        if(type === 'top'){
            $('#noahs_page_builder_preview').contents().find('#widget-id-' + widget_id).children('.noahs-divider-svg.top').remove();
        }
        if(type === 'bottom'){
            $('#noahs_page_builder_preview').contents().find('#widget-id-' + widget_id).children('.noahs-divider-svg.bottom').remove();
        }

        $('.update_data_form').trigger('change');
    })

    $(document).on("keyup", '[name="element[separator_weight]"]', function(e){

        e.preventDefault();
        var contenidoIframe = $('#noahs_page_builder_preview').contents();
        var weight = $(this).val(); 
        var selector = $(this).data('selector'); 
        var currentStyle = contenidoIframe.find(selector).attr('style');
    
        var newStyle = currentStyle.replace(/(stroke-width="[^"]*")/, 'stroke-width="' + weight + '"');
        contenidoIframe.find(selector).attr('style', newStyle);

    })

    $(document).on("click", '.noahs_page_builder-add-item', function(e){
        e.preventDefault();
       
        const widget_id = $(this).closest('form').find('input[name="wid"]').val();
        var htmlData = $(this).data('html');
        var count = $(this).closest('.noahs_page_builder_multiple_elements').find('.accordion-item').length;
        

        var newHtml = htmlData.replace(/replace_it/g, (count + 1)).replace(/header_replace/, (count + 1));
        var $tempDiv = $('<div>').html(newHtml);

        const type = $(this).closest('form').find('input[name="type"]').val();
        $tempDiv.attr('data-delta', count);
        $tempDiv.find('.accordion-button').text('Item #' + (count + 1));
        $tempDiv.find('.accordion-header').attr('id', 'header_' + (count + 1));
        $tempDiv.find('.accordion-button').attr('data-bs-target', '#slideshow_' + (count + 1));
        $tempDiv.find('.accordion-button').attr('aria-controls', 'slideshow_' + (count + 1));
        $tempDiv.find('.accordion-collapse').attr('id', 'slideshow_' + (count + 1));
        $tempDiv.find('.accordion-collapse').attr('aria-labelledby', 'header_' + (count + 1));
        $tempDiv.find('[data-delta]').each(function() {
            $(this).attr('data-delta', (count + 1));
        });
        var updatedHtml = $tempDiv.html();

        $(this).closest('.noahs_page_builder_multiple_elements').find('.accordion').append(updatedHtml);

        ckeditor(widget_id);

        var formData = $(this).closest('form').find(':input').filter(function () {
            return $.trim(this.value).length > 0
        }).serializeJSON();

        modificarJson(this, widget_id);
        regenerateWidget(widget_id, formData);
        updateIframeFunctions();
    })

    $(document).on("click", '.noahs_page_builder-remove-item', function(e){
        e.preventDefault();
        var $element = $(this);
        var $form = $element.closest('form'); // Obtener referencia al formulario
        
        // Obtener formData antes de eliminar el elemento
       
        var widget_id = $form.find('input[name="wid"]').val();
    
        var $accordionItem = $element.closest('.accordion-item'); // Guardar referencia al elemento a eliminar
    
        // Eliminar el elemento después de obtener formData
        $accordionItem.remove();
        var formData = $form.find(':input').filter(function () {
            return $.trim(this.value).length > 0
        }).serializeJSON();
    
        
        // Modificar JSON y regenerar widget
        modificarJson($element, widget_id);
        regenerateWidget(widget_id, formData);
        updateIframeFunctions();
    });
    

    $(document).on("click", '.noahs_page_builder-duplicate-item', function(e){
        e.preventDefault();
    
        var $currentItem = $(this).closest('.accordion-item');
        var $clonedItem = $currentItem.clone();
        var widget_id = $(this).closest('form').find('input[name="wid"]').val();
        var currentDelta = $currentItem.data('delta');
        var count = ($currentItem.closest('.noahs_page_builder_multiple_elements').find('.accordion-item').length + 1);
    
        $clonedItem.attr('data-delta', count);
        $clonedItem.find('.accordion-button').text('Item #' + count);
        $clonedItem.find('.accordion-header').attr('id', 'header_' + count);
        $clonedItem.find('.accordion-button').attr('data-bs-target', '#slideshow_' + count);
        $clonedItem.find('.accordion-button').attr('aria-controls', 'slideshow_' + count);
        $clonedItem.find('.accordion-collapse').attr('id', 'slideshow_' + count);
        $clonedItem.find('.accordion-collapse').attr('aria-labelledby', 'header_' + count);
        $clonedItem.find('[data-delta]').each(function() {
            $(this).attr('data-delta', count);
        });
        $clonedItem.find('[data-element-id]').each(function() {
            var unicid = Math.floor(Math.random() * 10000);
            $(this).attr('data-element-id', $(this).data('element-id').replace(currentDelta, unicid));
            $(this).attr('id', $(this).data('element-id').replace(currentDelta, unicid));
            $(this).data('elementId', $(this).data('element-id').replace(currentDelta, unicid));
        });

        $currentItem.after($clonedItem);
        $clonedItem.find('[name*="[element_' + currentDelta + '"]').each(function() {

            var currentName = $(this).attr('name');
            var newName = currentName.replace('[element_' + currentDelta + ']', '[element_' + count + ']');
            var updateSelector = $(this);
    
            $(this).attr('name', newName);
    
            var newUpdateSelector = updateSelector.data('update-selector');
    
            updateSelector.attr('name', newName); 
            if(newUpdateSelector != undefined){
                updateSelector.attr('data-update-selector', newUpdateSelector.replace('multipart-item_element_' + currentDelta, 'multipart-item_element_' + count));
                $(this).data('updateSelector', newUpdateSelector.replace('multipart-item_element_' + currentDelta, 'multipart-item_element_' + count));


            }
        });
       
        var formData = $(this).closest('form').find(':input').filter(function () {
            return $.trim(this.value).length > 0
        }).serializeJSON();
  
        modificarJson(this, widget_id);
        regenerateWidget(widget_id, formData);
        ckeditor(widget_id);

        updateIframeFunctions();
    });

    $(document).on("change", '#noahs_page_builder_animation_extra select[name="element[attribute][element_animation]"]', function () {
        updateIframeFunctions();
      });



    $(document).ready(function() {

        $('[data-bs-toggle="tooltip"]').tooltip();
        var contenidoIframe = $('#noahs_page_builder_preview').contents().find('#noahs_page_builder').html();

        $('.noahs_page_builder_preview-content').resizable({
            handles: {
              'e': '.r',
              'w': '.l'
            }
        });

        
        $("#btn-desktop").on("click", function() {
            $(".noahs_page_builder_preview-content").css({
                "width": "100%",
            });
            $("#top-panel .btn-top-panel").removeClass('active');
            $(this).addClass('active');
        });
        $("#btn-tablet").on("click", function() {
            $(".noahs_page_builder_preview-content").css({
                "width": "840px",
            });
            $("#top-panel .btn-top-panel").removeClass('active');
            $(this).addClass('active');
        });
        $("#btn-mobile").on("click", function() {
            $(".noahs_page_builder_preview-content").css({
                "width": "460px",
            });
            $("#top-panel .btn-top-panel").removeClass('active');
            $(this).addClass('active');
        });
        
        $('.area_tooltip').tooltip({html: true});



        $('#noahs_page_builder_form_builder').on("submit", function(e){
            e.preventDefault();
            noahs_page_builderSavePage();
            reloadIframe()
            return false;
        })

        $('#noahs_page_builder_sttings_page_form').on("submit", function(e){
            e.preventDefault();
            noahs_page_builderSavePage();
            return false;
          })
    });
    
    function reloadIframe() {
        window.location.reload();

    }


    // GET STRUCTURE OF NOAHS 

    function getWidgetStructure(html) {
        var contenidoIframe;
        var did;

        if (html) {
            contenidoIframe = html;
        } else {
            contenidoIframe = $('#noahs_page_builder_preview').contents().find('#noahs_page_builder').html();
        }

        var iframeContent = $('#noahs_page_builder_preview').contents();
        did = $(iframeContent).find('#noahs_page_builder').data('did');

        var estructuraSerializada = [];

        function processSection(section) {
            var sectionId = $(section).data('widget-id');
            var type = $(section).data('type');
            var widget_type = $(section).data('widget-type');
            var settings = $(section).data('settings');

            var sectionData = {
                wid: sectionId,
                type: type,
                did: did,
                widget_type: widget_type,
                settings: settings,
                columns: []
            };


            $(section).children('.widget-wrapper').children().children().children().children('div[data-widget-type="column"]').each(function(index, column) {
                    var columnId = $(column).data('widget-id');
                var type = $(column).data('type');
                var widget_type = $(column).data('widget-type');
                var column_size = $(column).data('column-size');
                var settings = $(column).data('settings');

                var columnData = {
                    wid: columnId,
                    type: type,
                    did: did,
                    widget_type: widget_type,
                    column_size: column_size,
                    settings: settings,
                    elements: []
                };

                $(column).children('.widget-wrapper').children().children().children('.noahs_page_builder-widget').each(function(index, widget) {
                    var widgetId = $(widget).data('widget-id');
                    var type = $(widget).data('type');
                    var widget_type = $(widget).data('widget-type');
                    var settings = $(widget).data('settings');
                    var global = $(widget).data('widget-global');

                    var elementsData = {
                        wid: widgetId,
                        type: type,
                        did: did,
                        widget_type: widget_type,
                        settings: settings,
                        global: global,
                    };

                    if (widget_type === 'section') {
                        var sectionElements = processSection(widget);
                        columnData.elements.push(sectionElements);
                    } else {
                        columnData.elements.push(elementsData);
                    }
                });

                sectionData.columns.push(columnData);
            });

            return sectionData;
        }

        $(contenidoIframe).children('section[data-widget-type="section"]').each(function(index, section) {
            var processedSection = processSection(section);
            estructuraSerializada.push(processedSection);
        });

        var estructuraSerializadaJSON = JSON.stringify(estructuraSerializada);

        return estructuraSerializadaJSON;
    }


    // formulario de edicion modal

    function noahs_page_builderOpenModal(form){
        $('#noahs_page_builder_preview').contents().find('.noahs_page_builder_loading').remove();
        $('.noahs_page_builder-modal').remove();

        $('body').append(form);
    
        $(document).trigger('myAjaxFinished');
        const widget_id = $(form).find('input[name="wid"]').val();

        setTimeout(function() {
            $('.noahs_page_builder-modal').css('left', '0');
        }, 500);

        const formElement = $('.noahs_page_builder-modal form');
        ckeditor(widget_id);

        $('.background-image-field').each(function(index) {
            var bg_fid = $(this).find('.background-fid');
            var bg_thumb = $(this).find('.background-thumbnail').val();
            if(bg_thumb){
                $(this).find('.background-thumbnail-image').attr('src',bg_thumb).show();
            }
        });

        $('.media-uploadbg_image').on('click', function (e) {
            e.preventDefault();
            var element_id = $(this).data('element-id');
            var name = $(this).data('element-id');
            openMediaModal(element_id, 'image', 'single', null, widget_id);
        });

        $('#add_multiple_images_field').on('click', function (e) {
            e.preventDefault();

            var element_id = $(this).data('element-id');
            var elements =  $('.noahs_page_builder_gallery_field').find('.image-box').length;
            openMediaModal(element_id, 'image','multiple', elements, widget_id);
        });

        $('.media-upload_video').on('click', function (e) {
            e.preventDefault();

            var element_id = $(this).data('element-id');
            var elements =  $('.noahs_page_builder_gallery_field').find('.image-box').length;
            openMediaModal(element_id, 'video', 'single', null, widget_id);
        });

        $('.media-preview-actions--divider input').on('change', function() {
            const widget_id = $(this).closest('form').find('input[name="wid"]').val();
            var type =  $(this).data('type');

            if(type === 'top'){
                $('#noahs_page_builder_preview').contents().find('#widget-id-' + widget_id).children('.noahs-divider-svg.top').remove();
                var svg = $(this).next().prop('outerHTML')
                var html = '<div class="noahs-divider-svg top">' +svg+ '</div>';
                $('#noahs_page_builder_preview').contents().find('#widget-id-' + widget_id).prepend(html);
        
            }
            if(type === 'bottom'){
                $('#noahs_page_builder_preview').contents().find('#widget-id-' + widget_id).children('.noahs-divider-svg.bottom').remove();
                var svg = $(this).next().prop('outerHTML')
                var html = '<div class="noahs-divider-svg bottom">' +svg+ '</div>';
        
                $('#noahs_page_builder_preview').contents().find('#widget-id-' + widget_id).append(html);
            }

        });

        // divider
        
        // $(".field__noahs_divider").each(function(index) {

        //     const widget_id = $(this).closest('form').find('input[name="wid"]').val();
      
        //     $(this).find('input, select, :checkbox, :radio').on('change', function() {
        //         modificarJson(this, widget_id);

        //     });

        // });
    
        $("#noahs_page_builder_edit_widget_form").on("mousedown", ".noahs-input--control-css", function() {
         
            $(this).each(function(index) {
                const widget_id = $(this).closest('form').find('input[name="wid"]').val();
                var styleStype = $(this).data('style-type');
                var styleSelector = $(this).attr('data-style-selector');
                var attributeType = $(this).data('attribute-type');

                if (styleSelector != undefined) {
                    $(this).find('input, select, :checkbox, :radio').each(function(index) {
                        var localStyleSelector = styleSelector; // Captura el valor actual del estilo
            
                        if (localStyleSelector === 'widget') {
                            localStyleSelector = '#widget-id-' + widget_id;
                        } else if (!localStyleSelector.includes('#widget-id-' + widget_id)) {
                            localStyleSelector = '#widget-id-' + widget_id + ' ' + localStyleSelector;
                        }
                        var targetElement = $('#noahs_page_builder_preview').contents().find(localStyleSelector);
                        var stringClass = targetElement.attr('class');
                        if($(this).is('select')){
                            var selectedValue = $(this).val();
                        }
            
                        $(this).on('change keyup', function() {
                        
                            if (styleStype == 'style' && styleStype !== false) {
                                modificarEstilo(this, widget_id);
                                modificarJson(this, widget_id);
                            } else if (styleStype == 'class' && styleStype !== false) {

                                var targetElement = $('#noahs_page_builder_preview').contents().find(localStyleSelector);
                        
                                if($(this).attr('type') === 'checkbox'){
                                
                                    if ($(this).is(':checked')) {
                                        targetElement.addClass($(this).val());
                                    }else{
                                        targetElement.removeClass($(this).val());
                                    }
                                }else if($(this).is('select')){
                                    
                                    targetElement.removeClass(selectedValue);
                                    targetElement.addClass($(this).val());
                                
                                }else{
                                    if (stringClass != '') {
                                        var newClass = stringClass + ' ' + $(this).val();
                                        targetElement.attr('class', newClass);
                                    }
                                }
                                if($(this).is("[name='element[class][gallery_type_columns]']")){
                                    targetElement.attr('class', 'row ' + $(this).val());
                                }
                                modificarJson(this, widget_id);
                    
                            } else if (styleStype == 'attribute' && styleStype !== false) {
                                var targetElement = $('#noahs_page_builder_preview').contents().find(localStyleSelector);
                                var attributeValue = $(this).val();
                                if (attributeValue) {
                                    targetElement.attr(attributeType, attributeValue);
                                }

                                modificarJson(this, widget_id);
                                contenidoIframe = $('#noahs_page_builder_preview').contents().find('#noahs_page_builder').html();
                                updateIframeFunctions(contenidoIframe);
                            }
                        });
                    });
                }else{
                    $(this).find('input, select, :checkbox, :radio').each(function(index) {
                        $(this).on('change keyup', function() {
                            modificarJson(this, widget_id);
                         
                        });
                    });
                }
            });
        });
        
        
        

        formElement.on("submit", function(e){
            e.preventDefault();
            var formData = $(this).find(':input').filter(function () {
                return $.trim(this.value).length > 0
            }).serializeJSON();

            const widget_id = $('input[name="wid"]').val();

            $('#noahs_page_builder_preview').contents().find('#widget-id-' + widget_id).attr('data-settings', JSON.stringify(formData));
            noahs_page_builderSavePage();
            reloadIframeAndCheckForErrors();
            reloadIframe();
            return false;
        })

        $('.noahs_page_builder_textarea').on('change', function (param) {
            var selector = $(this).data('update-selector');
            $(contenidoIframe).find(selector).html($(this).val());
        });
  
        $('.media-removebg_image').on("click", function(e){
            e.preventDefault();
            $(this).closest('.background-image-field').find('input').val('');
            $(this).closest('.background-image-field').find('.background-thumbnail-image').attr('src', '').hide();
            $(this).closest('.media-preview-actions').find('.background-fid').trigger('change');
        })

        $('.noahs_page_builder-edit-grid-item').on("click", function(e){
            e.preventDefault();
        })

        $('.noahs_page_builder-remove-grid-item').on("click", function(e){
            e.preventDefault();
            $(this).closest('.image-box').remove();
        })

        $('.noahs_page_builder-close-modal').on("click", function(e){
            e.preventDefault();
            const widget_id = $('input[name="wid"]').val();

            $('#noahs_page_builder_preview').contents().find('#widget-id-' + widget_id).removeClass('editing-widget');
            $('.noahs_page_builder-modal').css('left', '-100%');
            setTimeout(function() {
              
            $('.noahs_page_builder-modal').remove();
            }, 500);
    
        });
        $(".noahs_page_builder_multiple_elements .accordion").sortable({
            items: '.accordion-item',
            handle: ".noahs_page_builder-move-item",
            cursor: "move",
            opacity: 0.5,
            tart: function(event, ui) {
                index_start = ui.item.index(); //getting index of picked element
            },
            stop: function(event, ui) {
                var newIndex = ui.item.index();
                var oldIndex = ui.item.data('delta');
                $(".noahs_page_builder_multiple_elements .accordion-item").each(function(index) {
                    $(this).attr('data-delta', newIndex);
        
                    $(this).find('.noahs_page_builder-hover-modal input').each(function() {
                        var currentName = $(this).attr('name');
                        var newName = currentName.replace('element_' + oldIndex, 'element_' + newIndex);
                        $(this).attr('name', newName);
                    });
                });
                $('.update_data_form').trigger('change');
                const widget_id = $('input[name="wid"]').val();
                var formData = ui.item.closest('form').find(':input').filter(function () {
                    return $.trim(this.value).length > 0
                }).serializeJSON();
                regenerateWidget(widget_id, formData);
            }
        }).disableSelection();

        var iframe = $('#noahs_page_builder_preview').contents();
        var imagetosort = iframe.find('#widget-id-' + widget_id + ' .noahs_page_builder-gallery .gallery-item');


        var index_start = 0;
        var index_stop = 0;
        var swap_element = 0;
        var picked_element = 0;


        $(".noahs_page_builder_gallery_field .gallery-images-wrapper").sortable({
            items: '.image-box',
            handle: ".noahs_page_builder-move-grid-item",
            cursor: "move",
            opacity: 0.5,
            start: function(event, ui) {
                index_start = ui.item.index(); //getting index of picked element
            },
            update: function(event, ui) {
                index_stop = ui.item.index();
                picked_element =  iframe.find('#widget-id-' + widget_id + ' .noahs_page_builder-gallery .gallery-item:eq(' + index_start + ')');
                swap_element =  iframe.find('#widget-id-' + widget_id + ' .noahs_page_builder-gallery .gallery-item:eq(' + index_stop + ')');
                // swap_element = $('.l2:eq(' + index_stop + ')');
                swap_element.replaceWith(picked_element);
                //replaceWith method of javascript removes the picked_element from its original    
                //position & replaces swap_element with picked_element
                if (index_start > index_stop){
                    picked_element.after(swap_element);
                }else{
                    picked_element.before(swap_element);
                }
            },
            stop: function(event, ui) {
                var newIndex = ui.item.index();
                var oldIndex = ui.item.data('delta');
                $(".gallery-images-wrapper .image-box").each(function(index) {
                    $(this).attr('data-delta', index);
                    var hoverModalId = 'edit-gallery-image-' + index;
        
                    $(this).find('.noahs_page_builder-hover-modal').attr('id', hoverModalId);
                    $(this).find('.noahs_page_builder-edit-grid-item').attr('data-show-click', '#' + hoverModalId);
        
                    $(this).find('.noahs_page_builder-hover-modal input[name^="element[gallery_items]"]').each(function() {
                        var currentName = $(this).attr('name');
                        var newName = currentName.replace(/\[\d+\]/, '[' + index + ']');
                        $(this).attr('name', newName);
                    });
                });

        
                $('.update_data_form').trigger('change');
            }
        }).disableSelection();
        
        $('.expand-field').on('click', function () {
            $(this).parent().toggleClass('active'); 
        });
       
        
        fieldStates();
    }


    function modificarEstilo($this, widget_id) {
        var iframe = $('#noahs_page_builder_preview').contents();
        var formData = $($this).closest('form').find(':input').filter(function () {
            return $.trim(this.value).length > 0
        }).serializeJSON();
        
        iframe.find('#widget-id-' + widget_id).attr('data-settings', JSON.stringify(formData));

        var data = {
            formData: formData,
        };
        $.ajax({
            url: '/noahs-admin/update_live_styles',
            type: 'POST',
            data: JSON.stringify(data),
            timeout: 1000,
            success: function (data) {
                var contenidoCSS = iframe.find('#w_style_' + widget_id);
                contenidoCSS.html(data.styles);
            },
            error: function (error) {
                console.log(error);
            }
        });

    }

    function updateIframeFunctions(html){

        var iframe = document.getElementById('noahs_page_builder_preview');
       
        if (iframe.contentWindow && iframe.contentWindow.NohasSwiperSlide) {
            iframe.contentWindow.NohasSwiperSlide(html);
        } else {
            console.error('La función no existe dentro del iframe.');
        }
    }
    function modificarJson($this, widget_id) {

        var iframe = $('#noahs_page_builder_preview').contents();
        var formData = $($this).closest('form').find(':input').filter(function () {
            return $.trim(this.value).length > 0
        }).serializeJSON();
        
        iframe.find('#widget-id-' + widget_id).attr('data-settings', JSON.stringify(formData));


    }
    function reloadIframeAndCheckForErrors() {
        var iframe = document.getElementById('noahs_page_builder_preview');
        
        iframe.onload = function() {
            var iframeDocument = iframe.contentDocument || iframe.contentWindow.document;
            var headContent = iframeDocument.head.innerHTML.trim();

            if (headContent === '') {
                console.log('El iframe se recargó pero el <head> está vacío. Puede haber ocurrido un error.');
                $('.noahs_page_builder-modal').addClass('error');
                $('#noahs_page_builder_form_builder').addClass('error');
            }
        };
        reloadIframe()
    }

    function openDialogToken(){
        var ajaxSettings = {
            url: '/noahs-admin/get_token',
            dialogType: 'modal',
            dialog: { width: 800 },
          };
          var myAjaxObject = Drupal.ajax(ajaxSettings);
          myAjaxObject.execute();
    }

    // Media modal
    function openMediaModal(element_id, source,  type, total, wid){

        var data = {
            element_id: element_id,
            type: type,
            source: source,
            wid: wid,
        };

        $.ajax({
        url: '/noahs-admin/noahs_page_builder/media-modal', 
        method: 'POST',
        data: JSON.stringify(data),
        success:function(data) {

            modal = data.html;

            $('body').append(modal);

            if(source === 'image'){
                if($(modal).hasClass('modal-type-multiple')){
                    $('.image-box').on('click', function(e) {
                        e.preventDefault();
                        $(this).toggleClass('selected');
                    });
                    $('.insert-media-modal').on('click', function() {
                        var selectedData = [];
                

                        $('.image-box.selected').each(function() {

                            var fileid = $(this).data('fileid');
                            var thumbnail = $(this).data('thumbnail');
                        
                            // Agregar los datos al array.
                            selectedData.push({
                                fileid: fileid,
                                thumbnail: thumbnail
                            });
                        });
                    
                        // Realizar la acción deseada con los datos seleccionados.
                        var timestamp = $.now();
                        var selectedHtml = '';
                        var newItems = '';
                        
                        for (var i = 0; i < selectedData.length; i++) {
                        var index = (total + i);
                        selectedHtml += '<div class="col-3 image-box mb-2 position-relative" data-delta="'+ index +'">';
                        selectedHtml += '<div class="noahs_gallery_field_actions">';
                        selectedHtml += '<div class="noahs_page_builder-edit-grid-item btn btn-sm btn-info position-absolute top-50 start-50 translate-middle rounded-circle" data-show-click="#edit-gallery-image-'+index+'"><i class="fa-solid fa-pen-to-square"></i></div>';
                        selectedHtml += '<div class="noahs_page_builder-move-grid-item btn btn-sm btn-info position-absolute top-0 start-0 rounded-circle"><i class="fa-solid fa-arrows-up-down-left-right"></i></div>';
                        selectedHtml += '<div class="noahs_page_builder-remove-grid-item btn btn-sm btn-danger position-absolute bottom-0 end-0 rounded-circle"><i class="fa-solid fa-trash"></i></div>';
                        selectedHtml += '</div>';
                        selectedHtml += '<img src="' + selectedData[i].thumbnail + '" data-fid="' + selectedData[i].fileid + '" style="width:100%; height:auto;">';

                        selectedHtml += '<div id="edit-gallery-image-'+index+'" class="noahs_page_builder-hover-modal bg-light p-3 position-absolute top-50 start-0 translate-middle-y shadow-lg hidden w-100">';
                        selectedHtml += '<div class="btn btn-sm btn-danger position-absolute top-0 start-50 translate-middle rounded-circle" data-show-click="#edit-gallery-image-'+index+'"><i class="fa-regular fa-circle-xmark"></i></div>';
                        selectedHtml += '<input type="hidden" name="element[gallery_items]['+ index +'][fid]" value="'+ selectedData[i].fileid +'">';
                        selectedHtml += '<input class="form-control" type="text" name="element[gallery_items]['+ index +'][url]" value="">';
                        selectedHtml += '<input type="hidden" name="element[gallery_items]['+ index +'][node_id]" value="">';
                        selectedHtml += '</div>';
                        
                        selectedHtml += '</div>';
                        newItems += '<div class="gallery-item col"><div class="noahs_page_builder-carousel--actions"><a data-fancybox="gallery" href="' + selectedData[i].thumbnail + '"><i class="fa-solid fa-magnifying-glass"></i></a></div><img class="gallery-image-src" src="' + selectedData[i].thumbnail + '"></div>'
                        }
                    

                        // Agregar el HTML al contenedor.
                        $('#' + element_id).append(selectedHtml);
                        $('.update_data_form').trigger('change');
                        var contenidoIframe = $('#noahs_page_builder_preview').contents().find('#widget-id-' + wid + ' .row').append(newItems);

                        $('.noahs_page_builder-media-modal').remove();
                        var formData = $('#' + element_id).closest('form').find(':input').filter(function () {
                            return $.trim(this.value).length > 0
                        }).serializeJSON();
                
                        regenerateWidget(wid, formData);
               
                    });
                }else{
                    $('.image-box').on('click', function(e){
                        e.preventDefault();
                        $('.image-box').removeClass('selected');
                        $(this).addClass('selected');
                        var fid = $(this).data('fileid');
                        var thumbnail = $(this).data('thumbnail');
                        $('.insert-media-modal').attr('data-fileid', fid).attr('data-thumbnail', thumbnail);
                    })
                    $('.insert-media-modal').on("click", function(e){
                        e.preventDefault();

                        var fid = $(this).data('fileid');
                        var thumbnail = $(this).data('thumbnail');
                        var element_id = $(this).data('element-id');
                        var wid = $(this).data('wid');

                        $('#' + element_id).val(fid);
                        $('#' + element_id).parent().find('.background-thumbnail-image').attr('src', thumbnail).show();
                        $('#' + element_id).parent().find('.background-thumbnail').val(thumbnail);
                        $('.noahs_page_builder-media-modal').remove();
                        var contenidoIframe = $('#noahs_page_builder_preview').contents().find('#widget-id-' + wid);
                        contenidoIframe.find('.widget-image-src').attr('src', thumbnail)
                        $('#' + element_id).trigger('change');
                        var formData = $('#' + element_id).closest('form').find(':input').filter(function () {
                            return $.trim(this.value).length > 0
                        }).serializeJSON();
                
                        regenerateWidget(wid, formData);

                    })
                }
            }
            if(source === 'video'){
                $('.image-box').on('click', function(e){
                    e.preventDefault();
                    $('.image-box').removeClass('selected');
                    $(this).addClass('selected');
                    var fid = $(this).data('fileid');
                    var thumbnail = $(this).data('thumbnail');
                    $('.insert-media-modal').attr('data-fileid', fid).attr('data-thumbnail', thumbnail);
                })
                $('.insert-media-modal').on("click", function(e){
                    e.preventDefault();

                    var fid = $(this).data('fileid');
                    var thumbnail = $(this).data('thumbnail');
                    var element_id = $(this).data('element-id');
                    var wid = $(this).data('wid');

                    $('#' + element_id).val(fid);
                    $('#' + element_id).parent().find('.noahs-video-iframe source').attr('src', thumbnail);
                    $('#' + element_id).parent().find('.noahs-video-iframe')[0].load();
                    $('#' + element_id).parent().find('.file-url').val(thumbnail);
                    $('.noahs_page_builder-media-modal').remove();

                    var contenidoIframe = $('#noahs_page_builder_preview').contents().find('#widget-id-' + wid);
                        contenidoIframe.find('.noahs-video-iframe source').attr('src', thumbnail);
                        contenidoIframe.find('.noahs-video-iframe')[0].load();
                        modificarJson($('.update_data_form'), wid);
                })
            }



            $('#noahs_page_builder_upload_image').on('change', function () {
              

                var files = $(this).prop("files");

                if (!files || files.length === 0) {
                    $('.modal-messages').append('<p>Por favor, selecciona al menos un archivo</p>');
                    return;
                }

                var formData = new FormData();

                for (var i = 0; i < files.length; i++) {
                    var fileInput = files[i];

                    if(source === 'video'){
                        // Verificar si el archivo es una video WEBM
                        if (fileInput.type !== 'video/mp4' && fileInput.type !== 'video/webm') {
                            $('.modal-messages').append('<p>Por favor, selecciona un archivo mp4 o webm</p>');
                            return;
                        }
                    }
    
                    if(source === 'image'){
                        if (fileInput.type !== 'image/jpeg' && fileInput.type !== 'image/png' && fileInput.type !== 'image/gif') {
                            $('.modal-messages').append('<p>Por favor, selecciona un archivo JPG o PNG</p>');
                            return;
                        }
                    }
               
                    formData.append('files[' + i + ']', fileInput);
                }

                $.ajax({
                    url: '/noahs-admin/noahs_page_builder/upload_file',
                    type: 'POST',
                    data: formData,
                    processData: false,
                    contentType: false,
                    success: function (data) {

                        $('#fileInput').val(null)
                        var files = data.files;

                        for (var i = 0; i < files.length; i++) {
                            var fileData = files[i];
                            if(source === 'image'){
                                $('.noahs_page_builder-modal_container .noahs-new-media-element').prepend('<div class="col-2 image-box mb-2 selected" data-fileid="' + fileData.file_id + '" data-thumbnail="' + fileData.file_url + '"><span><img src="' + fileData.file_url + '"></span></div>');
                            }
                            if(source === 'video'){
                                $('.noahs_page_builder-modal_container .noahs-new-media-element').prepend('<div class="col-2 image-box mage-box-video mb-2 selected" data-video-url="'+ fileData.file_fullurl +'" data-fileid="' + fileData.file_id + '"><video class="noahs-video-iframe" width="100%"><source src="'+ fileData.file_fullurl +'" type="'+fileData.file_name+'"><p>Su navegador no soporta vídeos HTML5.</p></video></div>');
                            }
                            $('.modal-messages').append('<div class="alert alert-success mt-3" role="alert"><i class="fa-solid fa-circle-check me-3"></i>' + data.message + '</div>');
                            $('.insert-media-modal').attr('data-fileid', fileData.file_id).attr('data-thumbnail', fileData.file_fullurl);
                        }

                        $('.image-box').on('click', function (e) {
                            e.preventDefault();
                            $('.image-box').removeClass('selected');
                            $(this).addClass('selected');
                            var fid = $(this).data('fileid');
                            $('.insert-media-modal').attr('data-fileid', fid);
                        });
                    },
                    error: function (error) {
                        $('.modal-messages').addClass('error').append('<div class="alert alert-danger" role="alert"><i class="fa-solid fa-circle-exclamation me-3"></i>' + data.message + '</div>');
                    }
                });
            });
        }, error: function (jqXHR, textStatus, errorThrown) {
            alert(textStatus + ":" + jqXHR.responseText);
            }
        });

    
    }

    // Icon modal
    function openIconModal(element_id, delta, wid){

        var data = {
            element_id: element_id,
            wid: wid,
            delta: delta,
        };

        $.ajax({
        url: '/noahs-admin/structure/noahs_page_builder/icons/modal',
        method: 'POST',
        data: JSON.stringify(data),
        success:function(data) {

            $('body').append(data);

                $('[data-icon]').on('click', function(e){
                    e.preventDefault();
                    $('[data-icon]').removeClass('selected');
                    $(this).addClass('selected');
                    var iconClass = $(this).data('icon');

                    $('.insert-media-modal').attr('data-icon-class', iconClass);
                    $('.insert-media-modal').removeAttr("data-fileid").removeAttr("data-thumbnail");
                })
                $('.image-box').on('click', function (e) {
                    e.preventDefault();
                    $('.image-box').removeClass('selected');
                    $(this).addClass('selected');
                    var fid = $(this).data('fileid');
                    var thumbnail = $(this).data('thumbnail');
                    $('.insert-media-modal').removeAttr("data-icon-class");
                    $('.insert-media-modal').attr('data-fileid', fid).attr('data-thumbnail', thumbnail);
                });
                $('[data-bs-toggle="tooltip"]').tooltip();

                $('#iconSearch').on('input', function() {

                    var searchText = $(this).val().toLowerCase();
            

                    $('[data-icon]').each(function() {
                        var iconData = $(this).data('icon').toString().toLowerCase();
                        var matchesSearch = iconData.includes(searchText);
            

                        $(this).toggle(matchesSearch);
                    });
                });

                $('#noahs_page_builder_upload_svg').on('change', function () {
              

                    var files = $(this).prop("files");
    
                    if (!files || files.length === 0) {
                        $('.modal-messages').append('<p>Por favor, selecciona al menos un archivo</p>');
                        return;
                    }
    
                    var formData = new FormData();
    
                    for (var i = 0; i < files.length; i++) {
                        var fileInput = files[i];
    
           
                        if (fileInput.type !== 'image/svg+xml') {
                            $('.modal-messages').append('<p>Por favor, selecciona un archivo SVG</p>');
                            return;
                        }

                        formData.append('files[' + i + ']', fileInput);
                    }
    
                    $.ajax({
                        url: '/noahs-admin/noahs_page_builder/upload_file',
                        type: 'POST',
                        data: formData,
                        processData: false,
                        contentType: false,
                        success: function (data) {
                            $('#fileInput').val(null)
                            var files = data.files;
    
                            for (var i = 0; i < files.length; i++) {
                                var fileData = files[i];
                                $('.noahs-customs-svg').prepend('<div class="col-2 image-box mb-2 selected" data-fileid="' + fileData.file_id + '" data-thumbnail="' + fileData.file_fullurl + '"><span><img src="' + fileData.file_fullurl + '" class="w-100"></span></div>');

                                $('.modal-messages').append('<div class="alert alert-success mt-3" role="alert"><i class="fa-solid fa-circle-check me-3"></i>' + data.message + '</div>');
                                $('.insert-media-modal').attr('data-fileid', fileData.file_id).attr('data-thumbnail', fileData.file_fullurl);
                            }
    
                            $('.image-box').on('click', function (e) {
                                e.preventDefault();
                                $('.image-box').removeClass('selected');
                                $(this).addClass('selected');
                                var fid = $(this).data('fileid');
                                var thumbnail = $(this).data('thumbnail');
                                $('.insert-media-modal').removeAttr("data-icon-class");
                                $('.insert-media-modal').attr('data-fileid', fid).attr('data-thumbnail', thumbnail);
                            });
                        },
                        error: function (error) {
                            $('.modal-messages').addClass('error').append('<div class="alert alert-danger" role="alert"><i class="fa-solid fa-circle-exclamation me-3"></i>' + data.message + '</div>');
                        }
                    });
                });

                $('.insert-media-modal').on("click", function(e){
                    e.preventDefault();
                    var iconClass = $(this).data('icon-class');
                    var element_id = $(this).data('element-id');
                    var fid = $(this).data('fileid');
                    var thumbnail = $(this).data('thumbnail');


                    if(thumbnail){
                        $('#' + element_id).parent().parent().find('#noahs_page_builder_icon_fid_' + delta).val(fid);
                        $('#' + element_id).parent().parent().find('#noahs_page_builder_icon_url_' + delta).val(thumbnail);
                        $('#' + element_id).parent().parent().find('#background_thumbnail_svg_' + delta).show().find('img').attr('src', thumbnail);

                        $('#' + element_id).closest('.media-preview-actions').find('#noahs_page_builder_icon_class_' + delta).val('');
                        $("#item").removeAttr('class');
                        $('#' + element_id).closest('.media-preview-actions').find('span').removeAttr('class')
                        $('#' + element_id).closest('.media-preview-actions').find('span').attr('class', '')

                    }else{
                        $('#' + element_id).closest('.media-preview-actions').find('#noahs_page_builder_icon_class_' + delta).val(iconClass);
                        $("#item").removeAttr('class');
                        $('#' + element_id).closest('.media-preview-actions').find('span').removeAttr('class')
                        $('#' + element_id).closest('.media-preview-actions').find('span').attr('class', iconClass)

                        $('#' + element_id).parent().parent().find('#noahs_page_builder_icon_fid_' + delta).val('');
                        $('#' + element_id).parent().parent().find('#noahs_page_builder_icon_url_' + delta).val('');
                        $('#' + element_id).parent().parent().find('#background_thumbnail_svg_' + delta).hide().find('img').attr('src', '');
                    }


             
                    
                  

                    const widget_id = $('#' + element_id).closest('form').find('input[name="wid"]').val();

            
                    var formData = $('#' + element_id).closest('form').find(':input').filter(function () {
                        return $.trim(this.value).length > 0
                    }).serializeJSON();
            
                    regenerateWidget(widget_id, formData);
           
                    
                    $('#' + element_id).trigger('change');
                    $('.noahs_page_builder-media-modal').remove();
                })
        

            $('.close-media-modal').on("click", function(e){
                e.preventDefault();
                $('.noahs_page_builder-media-modal').remove();
            })

            $('#noahs_page_builder_upload_image').on('change', function () {
                var files = $(this).prop("files");

                if (!files || files.length === 0) {
                    $('.modal-messages').append('<p>Por favor, selecciona al menos un archivo</p>');
                    return;
                }

                var formData = new FormData();

                for (var i = 0; i < files.length; i++) {
                    var fileInput = files[i];

                    // Verificar si el archivo es una imagen JPG o PNG
                    if (fileInput.type !== 'image/jpeg' && fileInput.type !== 'image/png') {
                        $('.modal-messages').append('<p>Por favor, selecciona un archivo JPG o PNG</p>');
                        return;
                    }

                    formData.append('files[' + i + ']', fileInput);
                }

                $.ajax({
                    url: '/noahs-admin/noahs_page_builder/upload_file',
                    type: 'POST',
                    data: formData,
                    processData: false,
                    contentType: false,
                    success: function (data) {


                        $('#fileInput').val(null)
                        var files = data.files;

                        for (var i = 0; i < files.length; i++) {
                            var fileData = files[i];
                            $('.noahs_page_builder-modal_container > .row').prepend('<div class="col-2 image-box mb-2 selected" data-fileid="' + fileData.file_id + '" data-thumbnail="' + fileData.file_url + '"><span><img src="' + fileData.file_url + '"></span></div>');
                            $('.modal-messages').append('<div class="alert alert-success mt-3" role="alert"><i class="fa-solid fa-circle-check me-3"></i>' + data.message + '</div>');
                            $('.insert-media-modal').attr('data-fileid', fileData.file_id).attr('data-thumbnail', fileData.file_url);
                        }
                        $('.image-box').on('click', function (e) {
                            e.preventDefault();
                            $('.image-box').removeClass('selected');
                            $(this).addClass('selected');
                            var fid = $(this).data('fileid');
                            $('.insert-media-modal').attr('data-fileid', fid);
                        });
                    },
                    error: function (error) {
                        $('.modal-messages').addClass('error').append('<div class="alert alert-danger" role="alert"><i class="fa-solid fa-circle-exclamation me-3"></i>' + data.message + '</div>');
                    }
                });
            });
      
        }, error: function (jqXHR, textStatus, errorThrown) {
            alert(textStatus + ":" + jqXHR.responseText);
            }
        });

    
    }

    //Añadir wl widget
    function addWidget(widget_id, extra_data){
        var data = {
        widget_id: widget_id,
        nid:  drupalSettings.nid,
        extra_data: extra_data,
        };


        var result="";
        $.ajax({
        url: '/noahs-admin/noahs_page_builder/widget/' + widget_id,
        method: 'POST',
        data: JSON.stringify(data),
        async: false,  
        success:function(data) {
            result =  data.html;
        },
        error: function (jqXHR, textStatus, errorThrown) {
            alert(textStatus + ":" + jqXHR.responseText);
        }
        });
     return result;  
    }

    //Get Default Template widget
    function getDefaultTemplate(type){
        var result="";
        $.ajax({
        url: '/noahs-admin/noahs_page_builder/default_widget_template/' + type,
        method: 'POST',
        async: false,  
        success:function(data) {
            result =  data.html;
        },
        error: function (jqXHR, textStatus, errorThrown) {
            alert(textStatus + ":" + jqXHR.responseText);
        }
        });

     return result;  
    }

    
    function regenerateWidget(widget_id, settings){
  

        var data = {
        settings: settings,
        widget_id: widget_id,
        };

        var result="";
        $.ajax({
        url: '/noahs-admin/noahs_page_builder/regenerate_widget',
        method: 'POST',
        data: JSON.stringify(data),
        async: false,  
        success:function(data) {
            var html = data.html;

            $('#noahs_page_builder_preview').contents().find('#widget-id-' + widget_id).replaceWith(html);

        },
        error: function (jqXHR, textStatus, errorThrown) {
            alert(textStatus + ":" + jqXHR.responseText);
        }
        });

    }

    // Obtener formulario del widget
    function addWidgetForm(widget_id, section_id){
  
        var data = {
        nid:  drupalSettings.nid,
        widget: widget_id,
        section_id: section_id,
        };

        var result="";
        $.ajax({
        url: '/modal-form/' + drupalSettings.nid + '/' + widget_id + '/' + section_id, // Reemplaza con la URL de tu ruta de Ajax.
        method: 'POST',
        data: JSON.stringify(data),
        async: false,  
        success:function(data) {

            result =  data;
        },
        error: function (jqXHR, textStatus, errorThrown) {
            alert(textStatus + ":" + jqXHR.responseText);
        }
        });
     return result;  
    }


    // Guardar Página
    function noahs_page_builderSavePage() {
        var settings = getWidgetStructure();
        var global_widgets = findAllGlobalTrue(jQuery.parseJSON(settings));

        if(global_widgets){
            global_widgets.forEach(element => {

                var data = {
                    widget_id: element.wid,
                    langcode: drupalSettings.langcode,
                    settings: JSON.stringify(element.settings),
                    widget_type: element.type,
                };

        
                $.ajax({
                    url: '/noahs-admin/noahs_page_builder/save-widget-global',
                    method: 'POST',
                    data: JSON.stringify(data),
                    async: false,  
                    success:function(data) {

                    },
                    error: function (jqXHR, textStatus, errorThrown) {
                        alert(textStatus + ":" + jqXHR.responseText);
                    }
                });
            });
        }

        var pageSettings = $('#noahs_page_builder_sttings_page_form').serializeJSON();

        var data_id = drupalSettings.did;
        var data = {    
            nid: data_id,
            did: drupalSettings.did,
            uid: drupalSettings.uid,
            langcode: drupalSettings.langcode,
            settings: settings,
            page_settings: JSON.stringify(pageSettings),
        };
        if(drupalSettings.theme_builder){
            data_id = drupalSettings.theme_builder_type;
            var data = {    
                type: data_id,
                langcode: drupalSettings.langcode,
                settings: settings,
                page_settings: JSON.stringify(pageSettings),
            };
        }

        $.ajax({
            url: drupalSettings.savePage,
            type: 'POST',
            data: data,
            dataType: 'json',
            success: function (data) {

                $.ajax({
                    url: '/noahs-admin/save-styles/' + drupalSettings.entity_id +'/' + data_id,
                    type: 'POST',
                    dataType: 'json',
                    success: function (data) {
                 
                        createAlert('','Styles Saved or updated!','everything went well.','info',true,true,'pageMessages');     
                    },
                    error: function (jqXHR, textStatus, errorThrown) {
                        createAlert('Opps!',textStatus + ":" +  'Something went wrong','Check your drupal Recent log messages.','danger',true,false,'pageMessages');
                    }
                });
            },
            error: function (jqXHR, textStatus, errorThrown) {
                console.log(errorThrown);
                createAlert('Opps!',textStatus + ":" +  'Something went wrong','Check your drupal Recent log messages.','danger',true,false,'pageMessages');
            }
        });

    }

    function findAllGlobalTrue(obj) {
        let results = [];
      
        function recurse(o) {
          if (typeof o !== 'object' || o === null) {
            return;
          }
      
          if (o.global === true) {
            results.push(o);
          }
      
          for (var key in o) {
            if (o.hasOwnProperty(key)) {
              recurse(o[key]);
            }
          }
        }
      
        recurse(obj);
        return results;
      }
    //Obtener html del widget

    function getFinalWidget(settings){
        
        var result = settings;
        var data = {
            nid: result['did'],
            widget: result['type'],
            wid: result['wid'],     
            settings: JSON.stringify(settings),
        };


        $.ajax({
            url: '/noahs-admin/final-widget/'+ result['did'] +'/'+ result['type'] +'/' + result['wid'],
            type: 'POST',
            data: data,
            dataType: 'json',
            success: function (data) {

                var contenidoIframe = $('#noahs_page_builder_preview').contents().find('#widget-id-' + result['wid']);
                contenidoIframe.replaceWith(data.html)
                var slider = $('#noahs_page_builder_preview').contents().find('#widget-id-' + result['wid'] + ' .noahs_page_builder-slideshow');
                var slide = new Swiper(slider, {
                    autoplay: {
                        delay: 5000,
                    },
                    pagination: {
                        el: ".swiper-pagination",
                    },
                    navigation: {
                        nextEl: '.swiper-button-next',
                        prevEl: '.swiper-button-prev', 
                    }
                });


            },
            error: function (jqXHR, textStatus, errorThrown) {
                console.log(errorThrown);
                createAlert('Opps!',textStatus + ":" +  'Something went wrong','Check your drupal Recent log messages.','danger',true,false,'pageMessages');
            },
            complete: function () {
            }
        });

    }
    
    // Añadir columna
    function noahs_page_builderAddColum(widget_id) {
        $('#noahsAddColumn').modal('show');
        $('.noahs_page_builder-column-modal .column-box').off('click');
        $('.noahs_page_builder-column-modal .column-box').on('click', function () {
            var default_data = {
                width: $(this).data('column'),
            };
            var html = addWidget('noahs_column', default_data);
            $('#noahs_page_builder_preview').contents().find('section[id="widget-id-' + widget_id + '"]').find('.row-elements').append(html);
            // $('#noahs_page_builder_preview').contents().find('div[id="' + $(html).attr('id') + '"]').attr('data-column-size', $(this).data('column')).addClass($(this).data('column'));
            $('#noahsAddColumn').modal('hide');
        });

    }

    // Añadir Widget
    function addElementWidgetModal(element_id){
    
        $('#addElementWidgetModal').modal('show');
        $('.noahs_page_builder-element-widget-modal .widget-box_element.widget').off('click').on('click', function(){
            var element = $(this).data('element');
            var html = addWidget(element);
            $('#noahs_page_builder_preview').contents().find('div[id="widget-id-'+element_id+'"]').children('.widget-wrapper').children().children('.noahs_page_builder-column--content-inner').append(html);
            $('#addElementWidgetModal').modal('hide');
            updateIframeFunctions();
        });
        $('.noahs_page_builder-element-widget-modal .widget-box_element.global').off('click').on('click', function(){
            var id = $(this).data('id');
            var html = addElementWidgetGlobal(id);
            $('#noahs_page_builder_preview').contents().find('div[id="widget-id-'+element_id+'"]').children('.widget-wrapper').children().children('.noahs_page_builder-column--content-inner').append(html);
            $('#addElementWidgetModal').modal('hide');
            updateIframeFunctions();
        });
      
    }
    // Añadir widget global
    function addElementWidgetGlobal(id){
        var data = {
         id:  id,
        };
        
        var result="";
        $.ajax({
        url: '/noahs-admin/noahs_page_builder/get-global-widget',
        method: 'POST',
        data: JSON.stringify(data),
        async: false,  
            success:function(html) {
                result =  html;
            },
            complete:function(e) {


            },
            error: function (jqXHR, textStatus, errorThrown) {
                alert(textStatus + ":" + jqXHR.responseText);
            }
        });
        return result; 
    }

    // mostras alertas
    function createAlert(title, summary, details, severity, dismissible, autoDismiss, appendToId) {
        
        var iconMap = {
            info: "fa fa-info-circle",
            success: "fa fa-thumbs-up",
            warning: "fa fa-exclamation-triangle",
            danger: "fa ffa fa-exclamation-circle"
        };

        var iconAdded = false;

        var alertClasses = ["alert", "animated", "flipInX"];
        alertClasses.push("alert-" + severity.toLowerCase());

        if (dismissible) {
            alertClasses.push("alert-dismissible");
        }

        var msgIcon = $("<i />", {
            "class": iconMap[severity] 
        });

        var msg = $("<div />", {
            "class": alertClasses.join(" ") 
        });

        if (title) {
            var msgTitle = $("<h4 />", {
            html: title
            }).appendTo(msg);
            
            if(!iconAdded){
                msgTitle.prepend(msgIcon);
                iconAdded = true;
            }
        }

        if (summary) {
            var msgSummary = $("<strong />", {
            html: summary
            }).appendTo(msg);
            
            if(!iconAdded){
            msgSummary.prepend(msgIcon);
            iconAdded = true;
            }
        }

        if (details) {
            var msgDetails = $("<p />", {
                html: details
            }).appendTo(msg);
            
            if(!iconAdded){
                msgDetails.prepend(msgIcon);
                iconAdded = true;
            }
        }

        if (dismissible) {
            var msgClose = $("<span />", {
            "class": "close", 
            "data-dismiss": "alert",
            html: "<i class='fa fa-times-circle'></i>"
            }).appendTo(msg);
        }
        
        $('#' + appendToId).prepend(msg);
        
        if(autoDismiss){
            setTimeout(function(){
            msg.addClass("flipOutX");
            setTimeout(function(){
                msg.remove();
            },1000);
            }, 5000);
        }
    }

    function resetField(field) {
        field.find('input').val('');
        field.find('select').val('');
        field.find('select option').removeAttr('selected');
        field.find('input[type="checkbox"]').prop('checked', false);
        field.find('textarea').text('');
    }
    
    function applyVisibility(showField, visible) {
        if (visible) {
            $('[data-field-name="' + showField + '"]').show();
        } else {
            $('[data-field-name="' + showField + '"]').hide();
            resetField($('[data-field-name="' + showField + '"]'));
        }
    }
    
    function fieldStates() {
        $('[data-field-state]').each(function() {
            var stateData = $(this).attr('data-field-state');
            var showField = $(this).data('field-name');
    
            if (stateData) {
                try {
                    var state = JSON.parse(stateData);
    
                    if (state) {
                        $.each(state.visible, function(selector, condition) {
                            var elements = $('[data-field-name="' + selector + '"]').find('[field-settings]');
    
                            if (elements.length > 0) {
                                var elementType = elements.attr('type');
                                var visible = false;
    
                                if (elementType === 'radio' || elementType === 'checkbox') {
                                    var elementChecked = elements.filter(':checked').val();
                                    visible = (elementChecked && elementChecked === condition.value);
                                } else {
                                    var elementValue = elements.val();
                                    visible = (elementValue && elementValue === condition.value);
                                }
    
                                applyVisibility(showField, visible);
                            }
                        });
                    }
                } catch (e) {
                    console.error('Error al analizar JSON:', e);
                }
            }
        });
    
        $('select[name^="element"], input[name^="element"], input[type="checkbox"], input[type="radio"]').change(function() {
            $('[data-field-state]').each(function() {
                var stateData = $(this).attr('data-field-state');
                var showField = $(this).data('field-name');
    
                if (stateData) {
                    try {
                        var state = JSON.parse(stateData);
    
                        if (state) {
                            $.each(state.visible, function(selector, condition) {
                                var elements = $('[data-field-name="' + selector + '"]').find('[field-settings]');
    
                                if (elements.length > 0) {
                                    var elementType = elements.attr('type');
                                    var visible = false;
    
                                    if (elementType === 'radio' || elementType === 'checkbox') {
                                        var elementChecked = elements.filter(':checked').val();
                                        visible = (elementChecked && elementChecked === condition.value);
                                    } else {
                                        var elementValue = elements.val();
                                        visible = (elementValue && elementValue === condition.value);
                                    }
    
                                    applyVisibility(showField, visible);
                                }
                            });
                        }
                    } catch (e) {
                        console.error('Error al analizar JSON:', e);
                    }
                }
            });
        });
    }

    var deletedIds = [];
    function removeWidgets(deletedId) {
        deletedIds.push(deletedId);
        mergedJSON = JSON.stringify(deletedIds);
        $('#widgets_to_remove').attr('data-remove-widgets', mergedJSON);
    }

    function ckeditor(wid){
        $('[noahs_page_builder-editor]').each(function (index, element) {
            if ($(this).next('.ck').length === 0) {
                $(this).attr('id', 'noahs_page_builder_editor_' + index);
                const editorElement = document.querySelector('#noahs_page_builder_editor_' + index);

                ClassicEditor
                .create(editorElement, {})
                .then(editor => {
                    editor.model.document.on('change:data', () => {
                        var selector = $(editor.sourceElement).data('update-selector');
                        var contenidoIframe = $('#noahs_page_builder_preview').contents().find(selector);

                       
                        $(contenidoIframe).html(editor.getData());
                        $(editorElement).html(editor.getData());
                        modificarJson(editorElement, wid);
                    });
                })
                .catch(error => {
                    console.error('Error al cargar el editor:', error);
                });
            }
        });
    }


})(jQuery, Drupal, drupalSettings);



