/**
 * @file
 * Javascript for Color Field.
 */

(function ($, Drupal, drupalSettings) {

    $(document).on('myAjaxFinished', function(event) {
        tabs()
      });
    $(document).ready(function() {
        tabs()
    });
  function tabs(){

    $(".noahs_page_builder-tabs-list a").click(function(e) {

        e.preventDefault();
        var tabId = $(this).attr("href");

        $(".noahs_page_builder-tab").hide();
        $(tabId).show();

        $(".noahs_page_builder-tabs-list a").removeClass("active");
        $(this).addClass("active");
    });
    $('.field_state_options').each(function(index, element){
        $(element).find('*[data-state]').change(function() {

            $(element).find('*[data-state-group="'+$(this).data('state')+'"]').hide();


            var selectedValue = $(this).val();

            $(element).find('*[data-state-element="' + selectedValue + '"]').show();
        });
    });
    
    var defaultValue = $('input[data-state]:checked').val();
    $('*[data-state-element="' + defaultValue + '"]').show();

    // Show the first tab and hide the rest
    $('.field__hover').each(function(index, element){

        $(element).find('.hover_tabs a:first-child').addClass('active');
        $(element).find('.field__hover-content').hide();
        $(element).find('.field__hover-content:first').show();

        // Click function
        $(element).find('.hover_tabs a').click(function(){
            $(element).find('.hover_tabs a').removeClass('active');
            $(this).addClass('active');
            $(element).find('.field__hover-content').hide();
        
            var activeTab = $(this).attr('href');
            $(activeTab).fadeIn();
          
            return false;
        });
    });
    


 // RESPONSIVE TABS
    // Show the first tab and hide the rest
    $('.noahs_page_builder_field__responsive').each(function(index, element){

        $(element).find('.responsive__tabs a:first-child').addClass('active');
        $(element).find('.field-wrapper').hide();
        $(element).find('.field-wrapper:first').show();

        // Click function
        $(element).find('.responsive__tabs a').click(function(){
            var query = $(this).data('query');
            $("#top-panel .btn-top-panel").removeClass('active');
            $("#top-panel " + '#btn-' + query).addClass('active');

            return false;
        });
        $(".responsive_tabs_tab_desktop").on("click", function() {
            $(".noahs_page_builder_preview-content").css({
                "width": "100%",
            });
            $(this).closest('form').find('.responsive__tabs a').removeClass('active');
            $('.noahs_page_builder_field__responsive .field-wrapper').hide();
            $(".responsive_tabs_tab_desktop").addClass('active');
            $('.field-wrapper-responsive-desktop').show();
        });

        $(".responsive_tabs_tab_tablet").on("click", function() {
            $(".noahs_page_builder_preview-content").css({
                "width": "840px",
            });
            $(this).closest('form').find('.responsive__tabs a').removeClass('active');
            $('.noahs_page_builder_field__responsive .field-wrapper').hide();
            $(".responsive_tabs_tab_tablet").addClass('active');
            $('.field-wrapper-responsive-tablet').show();
        });
        $(".responsive_tabs_tab_mobile").on("click", function() {
            $(".noahs_page_builder_preview-content").css({
                "width": "460px",
            });
            $(this).closest('form').find('.responsive__tabs a').removeClass('active');
            $('.noahs_page_builder_field__responsive .field-wrapper').hide();
            $(".responsive_tabs_tab_mobile").addClass('active');
            $('.field-wrapper-responsive-mobile').show();
        });

        $("#btn-desktop").on("click", function() {
            $('#noahs_page_builder_edit_widget_form').find('.responsive__tabs a').removeClass('active');
            $('.noahs_page_builder_field__responsive .field-wrapper').hide();
            $(".responsive_tabs_tab_desktop").addClass('active');
            $('.field-wrapper-responsive-desktop').show();
        });
        $("#btn-tablet").on("click", function() {
            $('#noahs_page_builder_edit_widget_form').find('.responsive__tabs a').removeClass('active');
            $('.noahs_page_builder_field__responsive .field-wrapper').hide();
            $(".responsive_tabs_tab_tablet").addClass('active');
            $('.field-wrapper-responsive-tablet').show();
        });
        $("#btn-mobile").on("click", function() {
            $('#noahs_page_builder_edit_widget_form').find('.responsive__tabs a').removeClass('active');
            $('.noahs_page_builder_field__responsive .field-wrapper').hide();
            $(".responsive_tabs_tab_mobile").addClass('active');
            $('.field-wrapper-responsive-mobile').show();
        });
    });
    // IF RESPONSIVE SELECTED BEFORE TABS
    var activeQuery = $('#top-panel .btn-top-panel.active').data('query');
   
    $('#noahs_page_builder_edit_widget_form').find('.responsive__tabs a').removeClass('active');
    $('.noahs_page_builder_field__responsive .field-wrapper').hide();
    $('.responsive_tabs_tab_' + activeQuery).addClass('active');
    $('.field-wrapper-responsive-' + activeQuery).show();
  }

})(jQuery, Drupal, drupalSettings);



