(function($) {
    $.fn.parallaxScroll = function(options) {
        // Opciones predeterminadas
        var settings = $.extend({
            speed: 0.5
        }, options);
        
        // Cache the Window object
        var $window = $(window);

        // Iterar sobre cada elemento seleccionado
        return this.each(function() {
            var $bgobj = $(this);

            // Función de desplazamiento
            $window.scroll(function() {
                // Scroll the background at var speed
                // the yPos is a negative value because we're scrolling it UP!
                var yPos = -($(window).scrollTop() / $bgobj.data('background-parallax'));
                
                // Put together our final background position
                var coords = '50% '+ yPos + 'px';

                // Move the background
                $bgobj.css({ backgroundPosition: coords });
            });
        });
    };
})(jQuery);
