<?php 
namespace Drupal\noahs_page_builder;
use Drupal\noahs_page_builder\Controls_Base;


class Control_Checkbox extends Controls_Base {

	public function get_type() {
		return 'checkbox';
	}

	public function content_template($data, $name, $value) {

		$attributes = '';
		$class = [];
		$class[] = 'form-check-input';
		$data_value = $data['item']['value'];
		$selector = !empty($data['item']['update_selector']) ? 'data-update-selector="#widget-id-' .$data['wid'] . ' ' .$data['item']['update_selector'].'"' : null;

		if(isset($data['delta'])){
			if (strpos($selector, '[index]') !== false) {
				$selector = str_replace('[index]', $data['delta'], $selector);
			} 
		}
		if(!empty($data['item']['attributes'])){
			$attributes =  implode(' ', array_map(
				function ($key, $value) {
					return sprintf('%s="%s"', $key, htmlspecialchars($value));
				},
				array_keys($data['item']['attributes']),
				$data['item']['attributes']
			));
			$class[] = !empty($data['item']['attributes']['class']) ? $data['item']['attributes']['class'] : null;
		}
		$class = implode(" ", $class);
		?>
		<?php ob_start() ?>
		<div class="form-check form-switch">
			<input type="checkbox" 
				   id="option-<?php echo $data['item_id']; ?>" 
				   name="<?php echo $name; ?>" 
				   value="<?php echo $data_value; ?>"  
					<?php echo $attributes; ?>
				   <?php  echo ($value == $data_value) ? 'checked' : null; ?>
				   class="<?php echo $class; ?>"  
				   <?php echo $selector; ?>
				   field-settings>
			<label for="option-<?php echo $data['item_id']; ?>" class="form-check-label"><?php echo $data['item']['title']; ?></label>
		</div>
		<?php return ob_get_clean();
	}
	public function render_control($data){
		return $this->base($data, $this->content_template($data));
	}
	protected function get_default_settings() {
		return [
			'input_type' => 'checkbox',
			'title' => '',
		];
	}
}

