<?php 

namespace Drupal\noahs_page_builder;

use Drupal\file\Entity\File;
use Drupal\image\Entity\ImageStyle;
use \Drupal\noahs_page_builder\Controller\NoahsController;

class Control_Noahs_Video_Upload{
	
	public function get_type() {
		return 'noahs_video_upload';
	}

	public function content_template($data, $name, $value) {
		$video_local_url = '/'.NOAHS_PAGE_BUILDER_PATH.'/assets/video/5772359_Coll_wavebreak_Animation_Emoji_1280x720.mp4';
		$file_name = 'video/mp4';

		if(!empty($value['fid'])){
			$video_file = File::load($value['fid']);
			$video_file_uri = $video_file->getFileUri();
			$file_name = $video_file->filemime->value;
			$video_local_url = \Drupal::service('file_url_generator')->generateAbsoluteString($video_file_uri);
	 	}
		?>
		<?php ob_start() ?>
		
	
		<div class="mb-3 background-image-field">
			<div class="media-preview-actions d-flex justify-content-center align-items-center mb-3">
          
               <video class="noahs-video-iframe" <?php echo $query_string; ?> width="100%">
                  	<source src="<?php echo $video_local_url; ?>" type="<?php echo $file_name; ?>">
            		<p>Su navegador no soporta vídeos HTML5.</p>
               </video>
				<input type="hidden" name="<?php echo $name; ?>[fid]" id="noahs_page_builder_video" value="<?php echo !empty($value['fid']) ? $value['fid'] : ''; ?>" class="form-control file-fid"  field-settings>
				<input type="hidden" name="<?php echo $name; ?>[url]" id="noahs_page_builder_video_url" value="<?php echo !empty($value['url']) ? $value['url'] : ''; ?>" class="form-control file-url"  field-settings>
				<div class="btn-group position-absolute d-flex justify-content-between w-100">
					<button class="btn btn-primary media-upload_video area_tooltip" title="<?php t('Add/change Video'); ?>" data-element-id="noahs_page_builder_video"><i class="fa-solid fa-circle-plus"></i></button>
					<button class="btn btn-danger media-remove_video area_tooltip"  title="<?php t('Remove Video'); ?>"><i class="fa-solid fa-trash"></i></button>
				</div>
			</div>
	
				
		</div>
		
	
		<?php return ob_get_clean();
	}

}