<?php 


use Drupal\noahs_page_builder\WidgetBase;

   class element_noahs_card extends WidgetBase{

      public function data(){
         return [
            'icon' => '<svg id="fi_3596091" enable-background="new 0 0 24 24" height="512" viewBox="0 0 24 24" width="512" xmlns="http://www.w3.org/2000/svg"><g><path d="m21.5 21h-19c-1.378 0-2.5-1.122-2.5-2.5v-13c0-1.378 1.122-2.5 2.5-2.5h19c1.378 0 2.5 1.122 2.5 2.5v13c0 1.378-1.122 2.5-2.5 2.5zm-19-17c-.827 0-1.5.673-1.5 1.5v13c0 .827.673 1.5 1.5 1.5h19c.827 0 1.5-.673 1.5-1.5v-13c0-.827-.673-1.5-1.5-1.5z"></path></g><g><path d="m7.5 12c-1.378 0-2.5-1.122-2.5-2.5s1.122-2.5 2.5-2.5 2.5 1.122 2.5 2.5-1.122 2.5-2.5 2.5zm0-4c-.827 0-1.5.673-1.5 1.5s.673 1.5 1.5 1.5 1.5-.673 1.5-1.5-.673-1.5-1.5-1.5z"></path></g><g><path d="m11.5 17c-.276 0-.5-.224-.5-.5v-1c0-.827-.673-1.5-1.5-1.5h-4c-.827 0-1.5.673-1.5 1.5v1c0 .276-.224.5-.5.5s-.5-.224-.5-.5v-1c0-1.378 1.122-2.5 2.5-2.5h4c1.378 0 2.5 1.122 2.5 2.5v1c0 .276-.224.5-.5.5z"></path></g><g><path d="m20.5 9h-6c-.276 0-.5-.224-.5-.5s.224-.5.5-.5h6c.276 0 .5.224.5.5s-.224.5-.5.5z"></path></g><g><path d="m20.5 13h-6c-.276 0-.5-.224-.5-.5s.224-.5.5-.5h6c.276 0 .5.224.5.5s-.224.5-.5.5z"></path></g><g><path d="m20.5 17h-6c-.276 0-.5-.224-.5-.5s.224-.5.5-.5h6c.276 0 .5.224.5.5s-.224.5-.5.5z"></path></g></svg>',
            'title' => 'Card',
            'description' => 'Description',
            'group' => 'General'
         ];
      }
      
      public function render_form(){
         $form = [];



         $form['section_content'] = [
            'type' => 'tab',
            'title' =>  t('Content')
         ];
         $form['card_style'] = [
            'type'      => 'select',
            'tab'     => 'section_content',
            'title'     => ('Cart Style'),
            'options' => [
               '' => 'Vertical',
               'h2' => 'Horizontal',
               'h3' => 'Image overlays',
            ],
         ];
         
         $form['image'] =[
            'type'    => 'noahs_image',
            'title'   => ('Image'),
            'tab' => 'section_content',
            'update_selector' => '.card-img-top',
            
         ];


         $form['card_group_text'] = [
            'type' => 'group',
            'title' => t('Title'),
         ];
         $form['card_title'] = [
            'type'    => 'text',
            'title'   => t('Title'),
            'tab' => 'section_content',
            'group' => 'card_group_text',
            'update_selector' => '.card-title > *',
         ];
         
         $form['heading_type'] = [
            'type'      => 'select',
            'tab'     => 'section_content',
            'title'     => ('Type'),
            'options' => [
               'h1' => 'H1',
               'h2' => 'H2',
               'h3' => 'H3',
               'h4' => 'H4',
               'h5' => 'H5',
               'h6' => 'H6',
            ],
            'update_selector_html' => '.card-title > *',
            'group' => 'card_group_text'
         ];

         $form['text'] = [
            'type'    => 'textarea',
            'title'   => t('Text'),
            'tab' => 'section_content',
            'group' => 'card_group_text',
            'update_selector' => '.card-text',
         ];

         $form['group_link'] = [
            'type' => 'group',
            'title' => t('Link'),
         ];
         $form['link_text'] = [
            'type'    => 'text',
            'title'   => t('Link Title'),
            'tab' => 'section_content',
            'group' => 'group_link',
            'update_selector' => '.btn'
            
         ];
         $form['link_url'] = [
            'type'    => 'noahs_url',
            'title'   => t('Link'),
            'tab' => 'section_content',
            'group' => 'group_link',
            'autocomplete' => 'url_autocomplete',
         ];
   
         $form['stretched_link'] = [
            'type'    => 'checkbox',
            'title'   => t('Stretched-link'),
            'tab' => 'section_content',
            'group' => 'group_link',
            'value' => 'stretched-link',
            'default_value' => '',
            'style_type' => 'class',
            'style_selector' => '.btn', 
            'update_selector' => '.btn', 
   
         ];
         $form['horizontal_align'] = [
            'type'    => 'select',
            'title'   => t('Horizontal Align'),
            'tab' => 'section_content',
            'group' => 'group_link',
            'style_type' => 'style',
            'style_selector' => '.btn-container', 
            'style_css' => 'justify-content',
            'responsive' => true,
            'options' => [
               '' => 'Por defecto',
               'flex-start' => 'Start',
               'center' => 'Center',
               'flex-end' => 'End',
            ]
         ];
         $form['button_target'] = [
            'type'    => 'select',
            'title'   => t('Target'),
            'tab' => 'section_content',
            'group' => 'group_link',
            'style_type'      => 'attribute',
            'style_selector'  => '.btn',
            'attribute_type'  => 'target',
            'options' => [
               '' => 'Opens in the same frame as it was clicked',
               '_blank' => 'Opens in a new window or tab',
               '_parent' => 'Opens in the parent frame',
               '_top' => 'Opens in the full body of the window',
               'framename' => 'Opens in the named iframe',
            ]
         ];


        



         // Section Styles
         $form['section_styles'] = [
            'type' => 'tab',
            'title' => t('Styles')
         ];



         $form['image_style_group'] = [
            'type' => 'group',
            'title' => t('Image')
         ];

         $form['image_background_color'] = [
            'type' => 'noahs_color',
            'title' => t('Background Color'),
            'tab' => 'section_styles',
            'group' => 'image_style_group',
            'style_type' => 'style',
            'style_selector' => '.widget-image-src', 
            'style_css' => 'background-color', 
            'style_hover' => true,
         ];


         $form['image_border'] = [
            'type' => 'noahs_border',
            'title' => t('Border'),
            'tab' => 'section_styles',
            'group' => 'image_style_group',
            'style_type' => 'style',
            'style_selector' => '.widget-image-src', 
            'style_css' => 'border', 
            'responsive' => true,
            'style_hover' => true,
         ];

         $form['image_margin'] = [
            'type' => 'noahs_margin',
            'title' => t('Margin'),
            'tab' => 'section_styles',
            'group' => 'image_style_group',
            'style_type' => 'style',
            'style_selector' => '.widget-image-src', 
            'style_css' => 'margin', 
            'responsive' => true,
            'style_hover' => true,
         ];

         $form['image_padding'] = [
            'type' => 'noahs_padding',
            'title' => t('Padding'),
            'tab' => 'section_styles',
            'group' => 'image_style_group',
            'style_type' => 'style',
            'style_selector' => '.widget-image-src', 
            'style_css' => 'padding', 
            'responsive' => true,
            'style_hover' => true,
         ];

         $form['image_shadows'] = [
            'type'    => 'noahs_shadows',
            'title'   => t('Image Shadow'),
            'tab' => 'section_styles',
            'group' => 'image_style_group',
            'style_type' => 'style',
            'style_selector' => '.widget-image-src', 
            'responsive' => true, 
            'style_hover' => true,
         ];
         $form['image_radius'] = [
            'type'    => 'noahs_radius',
            'title'   => t('Border Radius'),
            'tab' => 'section_styles',
            'group' => 'image_style_group',
            'style_type' => 'style',
            'style_selector' => '.widget-image-src', 
            'responsive' => true, 
            'style_hover' => true,
         ];
         $form['title_group'] = [
            'type' => 'group',
            'title' => t('Title'),
            'tab' => 'section_styles',
         ];
         
         $form['title_font'] = [
            'type' => 'noahs_font',
            'title' => t('Font'),
            'group' => 'title_group',
            'tab' => 'section_styles',
            'style_type' => 'style',
            'style_selector' => '.card-title > *', 
            'responsive' => true,
         ];

         $form['title_align'] = [
            'type'    => 'select',
            'title'   => t('Text Align'),
            'tab' => 'section_styles',
            'group' => 'title_group',
            'style_type' => 'style',
            'style_selector' => '.card-title', 
            'style_css' => 'text-align',
            'options' => [
               '' => 'Left',
               'center' => 'Center',
               'right' => 'Right',
            ]
         ];

         $form['title_margin'] = [
            'type' => 'noahs_margin',
            'title' => t('Margin'),
            'tab' => 'section_styles',
            'group' => 'title_group',
            'style_type' => 'style',
            'style_selector' => '.card-title', 
            'style_css' => 'margin', 
            'responsive' => true,
         ];

         $form['description_group'] = [
            'type' => 'group',
            'title' => t('Description'),
            'tab' => 'section_styles',
         ];
         
         $form['description_font'] = [
            'type' => 'noahs_font',
            'title' => t('Font'),
            'group' => 'description_group',
            'tab' => 'section_styles',
            'style_type' => 'style',
            'style_selector' => '.card-text', 
            'responsive' => true,
         ];


         $form['description_margin'] = [
            'type' => 'noahs_margin',
            'title' => t('Margin'),
            'tab' => 'section_styles',
            'group' => 'description_group',
            'style_type' => 'style',
            'style_selector' => '.card-text', 
            'style_css' => 'margin', 
            'responsive' => true,
         ];

         $form['button_group'] = [
            'type' => 'group',
            'title' => t('Button')
         ];

         $form['background_color'] = [
            'type' => 'noahs_color',
            'title' => t('Background Color'),
            'tab' => 'section_styles',
            'group' => 'button_group',
            'style_type' => 'style',
            'style_selector' => '.btn', 
            'style_css' => 'background-color', 
            'style_hover' => true,
         ];


         $form['border'] = [
            'type' => 'noahs_border',
            'title' => t('Border'),
            'tab' => 'section_styles',
            'group' => 'button_group',
            'style_type' => 'style',
            'style_selector' => '.btn', 
            'style_css' => 'border', 
            'responsive' => true,
            'style_hover' => true,
         ];

         $form['btn_margin'] = [
            'type' => 'noahs_margin',
            'title' => t('Margin'),
            'tab' => 'section_styles',
            'group' => 'button_group',
            'style_type' => 'style',
            'style_selector' => '.btn', 
            'style_css' => 'margin', 
            'responsive' => true,
            'style_hover' => true,
         ];

         $form['btn_padding'] = [
            'type' => 'noahs_padding',
            'title' => t('Padding'),
            'tab' => 'section_styles',
            'group' => 'button_group',
            'style_type' => 'style',
            'style_selector' => '.btn', 
            'style_css' => 'padding', 
            'responsive' => true,
            'style_hover' => true,
         ];

         $form['button_shadows'] = [
            'type'    => 'noahs_shadows',
            'title'   => t('Shadow'),
            'tab' => 'section_styles',
            'group' => 'button_group',
            'style_type' => 'style',
            'style_selector' => '.btn', 
            'responsive' => true, 
            'style_hover' => true,
         ];
         $form['button_radius'] = [
            'type'    => 'noahs_radius',
            'title'   => t('Border Radius'),
            'tab' => 'section_styles',
            'group' => 'button_group',
            'style_type' => 'style',
            'style_selector' => '.btn', 
            'responsive' => true, 
            'style_hover' => true,
         ];

         $form['box_group'] = [
            'type' => 'group',
            'title' => t('Background box Size')
         ];

         $form['car_background_color'] = [
            'type' => 'noahs_color',
            'title' => t('Background Color'),
            'tab' => 'section_styles',
            'group' => 'box_group',
            'style_type' => 'style',
            'style_selector' => '.card', 
            'style_css' => 'background-color', 
            'style_hover' => true,
         ];


         $form['car_border'] = [
            'type' => 'noahs_border',
            'title' => t('Border'),
            'tab' => 'section_styles',
            'group' => 'box_group',
            'style_type' => 'style',
            'style_selector' => '.card', 
            'style_css' => 'border', 
            'responsive' => true,
            'style_hover' => true,
         ];

         $form['card_margin'] = [
            'type' => 'noahs_margin',
            'title' => t('Margin'),
            'tab' => 'section_styles',
            'group' => 'box_group',
            'style_type' => 'style',
            'style_selector' => '.card', 
            'style_css' => 'margin', 
            'responsive' => true,
            'style_hover' => true,
         ];

         $form['card_padding'] = [
            'type' => 'noahs_padding',
            'title' => t('Padding'),
            'tab' => 'section_styles',
            'group' => 'box_group',
            'style_type' => 'style',
            'style_selector' => '.card', 
            'style_css' => 'padding', 
            'responsive' => true,
            'style_hover' => true,
         ];

         $form['card_shadows'] = [
            'type'    => 'noahs_shadows',
            'title'   => t('Image Shadow'),
            'tab' => 'section_styles',
            'group' => 'box_group',
            'style_type' => 'style',
            'style_selector' => '.card', 
            'responsive' => true, 
            'style_hover' => true,
         ];
         $form['card_radius'] = [
            'type'    => 'noahs_radius',
            'title'   => t('Border Radius'),
            'tab' => 'section_styles',
            'group' => 'box_group',
            'style_type' => 'style',
            'style_selector' => '.card', 
            'responsive' => true, 
            'style_hover' => true,
         ];

         return $form;
      }

      public function template( $settings ){

         $settings = $settings->element;

         $image = '/'.NOAHS_PAGE_BUILDER_PATH.'/assets/img/widget-image.jpg';
         if(!empty($settings->image->fid)){
		
				$file = File::load($settings->image->fid);
				$file_uri = $file->getFileUri();
				
				$image = ImageStyle::load($settings->image->image_style)->buildUrl($file_uri);
         }
         ?>
         <?php ob_start() ?>


               <div class="widget-content">
                  <div class="card">
                     <img class="card-img-top widget-image-src" src="<?php echo $image; ?>">
                     <div class="card-body">
                        <div class="card-title mb-4"><<?php echo ($settings->heading_type ?? 'h5'); ?>> <?php echo $settings->card_title ?? 'Card Title Here'; ?></<?php echo  ($settings->heading_type ?? 'h5'); ?>></div>
                        <div class="card-text mb-4"><?php echo $settings->text ?? 'This is the card text, please write here'; ?></div>
                        <div class="btn-container">
                           <a href="<?php echo !empty($settings->link_url) ? $settings->link_url : '#'; ?>" class="btn btn-<?php echo $settings->element->button_style ?? 'success'; ?>"><?php echo $settings->link_text ?? 'Button'; ?></a>
                        </div>
                     </div>
                  </div>
               </div>

         <?php return ob_get_clean() ?>  
         <?php       
      }
      public function render_content($element) {
         return $this->wrapper($element, $this->template($element->settings));
      }
   }

   



