<?php 


use Drupal\noahs_page_builder\WidgetBase;
use Drupal\views\Views;
use Drupal\commerce_cart\CartManagerInterface;
class element_noahs_drupal_views extends WidgetBase{

      public function data(){
         return [
            'icon' => '<i class="fa-brands fa-drupal"></i>',
            'title' => 'Drupal Views',
            'description' => 'Description',
            'group' => 'Drupal'
         ];
      }
      
      public function render_form(){
         $form = [];
         $options = noahs_page_builder_load_views();

         $form['drupal_block'] = [
            'type'    => 'select',
            'select_group_views'    => true,
            'title'   => t('Drupal Block'),
            'tab' => 'section_content',
            'options' => $options,
         ];
         
         $form['token'] = [
            'type'    => 'text',
            'title'   => t('Token'),
            'tab' => 'section_content',
            'description' => t('Use static or consult a token, separe with coma (,)')
         ];
         
         $form['token_button'] = [
            'type'    => 'html',
            'value'   => '<a class="btn btn-s btn-info noahs_page_builder-modal-tokens mb-4" href="#">Select Token</a>',
            'tab' => 'section_content'
         ];

         return $form;
      }

      public function template( $settings ){
         $render_block = '';
         $settings = $settings->element;

         if(!empty($settings->drupal_block)){
     
            $views_array = json_decode($settings->drupal_block);
            $view = Views::getView($views_array[0]);
         
            $display_id = Views::getView($views_array[1]);
            $render_block = '<div>Missing view, block "'.$settings->drupal_block.'"</div>';
       
            $args = null;
            if(!empty($settings->token->text)){
               $token_service = \Drupal::token();
               $token = $settings->token->text;
               $rendered_token = $token_service->replace($token);
               $args = $rendered_token;

            }

            $args = [$args];

            if (!$view->access($display_id)) {
           
          
        
               if($view){
                  $view->setDisplay($display_id);
                  $view->setArguments($args);
                  $view_render =   $view->buildRenderable($display_id);
                  $render_block = \Drupal::service('renderer')->render($view_render);

                  $render_block = !empty($render_block) ? $render_block ->__toString() : null;

         
               }
            }
  
         }
         $output = '';

         $output .= '<div class="widget-content">';
         if (!empty($render_block)) {
             $output .= $render_block;
         } else {
             $output .= '<div class="drupal-viewblock-empty">Drupal View</div>';
         }
         $output .= '</div>';
     
         return $output;   
      }
      public function render_content($element) {
         return $this->wrapper($element, $this->template($element->settings));
      }
   }

   



